=== debian/changelog ===
ros-lunar-opencv3 (3.3.1-2stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 22 Mar 2018 18:10:49 -0000
