=== debian/control ===
Source: ros-lunar-opencv3
Section: misc
Priority: extra
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libjpeg-dev, libpng-dev, libprotobuf-dev, libprotoc-dev, libswscale-dev, libtiff5-dev, libv4l-dev, libvtk6-qt-dev, libwebp-dev, protobuf-compiler, python-dev, python-numpy, zlib1g-dev
Homepage: http://opencv.org
Standards-Version: 3.9.2

Package: ros-lunar-opencv3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libjpeg-dev, libpng-dev, libprotobuf10, libswscale-dev, libvtk6-qt-dev, libwebp-dev, python-dev, python-numpy, ros-lunar-catkin, zlib1g-dev
Description: OpenCV 3.x
